LeetCode OJ:Jump Game(跳跃游戏)

Given an array of non-negative integers, you are initially positioned at the first index of the array.

Each element in the array represents your maximum jump length at that position.

Determine if you are able to reach the last index.

For example:
A = [2,3,1,1,4], return true.

A = [3,2,1,0,4], return false.

注意这里的每个位上的数是可以跳跃的最大长度,应该使用贪心策略,看了别人的实现,代码如下,以后好好思考下:

 1 class Solution {
 2 public:
 3     bool canJump(vector<int>& nums) {
 4         int sz = nums.size();
 5         if(!sz) return false;
 6         int left = nums[0];
 7         for(int i = 1; i < sz; ++i)
 8             if(left > 0){
 9                 left--;
10                 left = max(left, nums[i]);
11             }else return false;
12         return true;
13     }
14 };
时间: 2024-10-18 07:22:17

LeetCode OJ:Jump Game(跳跃游戏)的相关文章

LeetCode 55 _ Jump Game 跳跃游戏

Description: Given an array of non-negative integers, you are initially positioned at the first index of the array. Each element in the array represents your maximum jump length at that position. Determine if you are able to reach the last index. Exa

[Leetcode] jump game 跳跃游戏

Given an array of non-negative integers, you are initially positioned at the first index of the array. Each element in the array represents your maximum jump length at that position. Determine if you are able to reach the last index. For example:A =[

【LeetCode每天一题】Jump Game(跳跃游戏)

Given an array of non-negative integers, you are initially positioned at the first index of the array.Each element in the array represents your maximum jump length at that position.Determine if you are able to reach the last index. Example 1: Input:

LeetCode 第55题 跳跃游戏

给定一个非负整数数组,你最初位于数组的第一个位置. 数组中的每个元素代表你在该位置可以跳跃的最大长度. 判断你是否能够到达最后一个位置. 示例 1: 输入: [2,3,1,1,4]输出: true解释: 从位置 0 到 1 跳 1 步, 然后跳 3 步到达最后一个位置.示例 2: 输入: [3,2,1,0,4]输出: false解释: 无论怎样,你总会到达索引为 3 的位置.但该位置的最大跳跃长度是 0 , 所以你永远不可能到达最后一个位置. 思路: 贪心算法 . 尽可能向右移动, 如果能能到达

LeetCode(45): 跳跃游戏 II

Hard! 题目描述: 给定一个非负整数数组,你最初位于数组的第一个位置. 数组中的每个元素代表你在该位置可以跳跃的最大长度. 你的目标是使用最少的跳跃次数到达数组的最后一个位置. 示例: 输入: [2,3,1,1,4] 输出: 2 解释: 跳到最后一个位置的最小跳跃数是 2.   从下标为 0 跳到下标为 1 的位置,跳 1 步,然后跳 3 步到达数组的最后一个位置. 说明: 假设你总是可以到达数组的最后一个位置. 解题思路: 这题是之前那道Jump Game 跳跃游戏 的延伸,那题是问能不能

【LeetCode每天一题】Jump Game II(跳跃游戏II)

Given an array of non-negative integers, you are initially positioned at the first index of the array.Each element in the array represents your maximum jump length at that position.Your goal is to reach the last index in the minimum number of jumps.

Leetcode:Jump Game 跳跃楼梯

Jump Game: Given an array of non-negative integers, you are initially positioned at the first index of the array. Each element in the array represents your maximum jump length at that position. Determine if you are able to reach the last index. For e

[leetcode] 55. 跳跃游戏

55. 跳跃游戏 分明就是45. 跳跃游戏 II的缩水版本嘛..??,难度高的版本居然放在了前面,把像我这种有强迫症的必须按照题号刷题的人不放在眼里么... class Solution { public boolean canJump(int[] nums) { return jump(nums) != Integer.MAX_VALUE; } public int jump(int[] nums) { int f[] = new int[nums.length]; if (nums.leng

[Leetcode]44.跳跃游戏Ⅰ&amp;&amp;45.跳跃游戏Ⅱ

跳跃游戏链接 给定一个非负整数数组,你最初位于数组的第一个位置. 数组中的每个元素代表你在该位置可以跳跃的最大长度. 判断你是否能够到达最后一个位置. 示例 1: 输入: [2,3,1,1,4] 输出: true 解释: 从位置 0 到 1 跳 1 步, 然后跳 3 步到达最后一个位置. 示例 2: 输入: [3,2,1,0,4] 输出: false 解释: 无论怎样,你总会到达索引为 3 的位置.但该位置的最大跳跃长度是 0 , 所以你永远不可能到达最后一个位置. 思路: 如果只是判断能否跳到

LeetCode第四十五题-跳跃游戏

Jump Game II 问题简介:这是一个跳跃游戏,规则是通过给定一个非负整数数组,最开始就处于数组第一位即索引为0处,数组元素数值代表可以跳跃的最大值,要求通过最小的跳跃次数达到数组最后的索引处 举例: 输入: [2,3,1,1,4] 输出: 2 解释: 这个数组的最小跳跃值是2,第一次从索引0处跳跃1到索引1处,第二次跳跃3到结尾处 解法一: 当数组长度为1即无法跳跃,结果为0,找到每个点可以达到的最右端的值,进行判定 小白刷题之路,请多指教— — 要么大器晚成,要么石沉大海 原文地址:h